import static org.junit.Assert.*;

import java.util.LinkedList;

import org.junit.Test;

public class Examples {
	
	Node man = new Node("Manchester");
	Node bos = new Node("Boston");
	Node wor = new Node("Worcester");
	Node prov = new Node("Providence");
	Node hart = new Node("Hartford");
	
	Graph g = new Graph();
	
	LinkedList<Node> r1 = new LinkedList<Node>();
	LinkedList<Node> r2 = new LinkedList<Node>();
	
	public Examples() {
		
		g.addNode(man);
		g.addNode(bos);
		g.addNode(wor);
		g.addNode(prov);
		g.addNode(hart);
		
		g.addEdge(man, bos);
		g.addEdge(bos, wor);
		g.addEdge(bos, prov);
		g.addEdge(wor, bos);
		g.addEdge(prov, hart);
		
		g.addEdge(wor, hart);
		
		r1.add(bos);
		r1.add(prov);
		r1.add(hart);
		
		r2.add(bos);
		r2.add(wor);
		r2.add(hart);
	}
	
	@Test
	public void testBostMancHasRoute() {
		assertFalse(g.hasRoute(bos,  man));
	}
	
	@Test
	public void testMancMancHasRoute() {
		assertTrue(g.hasRoute(man,  man));
	}
	
	@Test
	public void testBosHartHasRoute() {
		assertTrue(g.hasRoute(bos, hart));
	}
	
	@Test
	public void testBosHartFindRoute() {
		LinkedList<Node> r = g.findRoute(bos, hart);
		assertTrue(r1.equals(r) || r2.equals(r));
	}

}
