import java.util.LinkedList;

public class Node {

	private String name;
	private LinkedList<Node> getsTo;
	
	Node(String name) {
		this.name = name;
		getsTo = new LinkedList<Node>();
	}
	
	public void addEdge(Node someNode)
	{
		this.getsTo.add(someNode);
	}
	
	boolean hasRoute(Node to, LinkedList<Node> visited) {
		if (this.equals(to))
			return true;
		else if (visited.contains(this))
			return false;
			else {
				visited.add(this);
				for (Node c : this.getsTo) {
					if (c.hasRoute(to, visited)) {
						return true;
	      			}
	    		}
				return false;
			}
	}
	
	public LinkedList<Node> findRoute(Node toNode, LinkedList<Node> visited) {
		if(this.equals(toNode)) {
			LinkedList<Node> result = new LinkedList<Node>();
			result.add(this);
			return result;
		}
		
		else if(visited.contains(this))
			return new LinkedList<Node>();
		else {
			visited.add(this);
			for (Node n: this.getsTo) {
				LinkedList<Node> nRoute = n.findRoute(toNode, visited);
				if(nRoute.size() > 0) {
					nRoute.addFirst(this);
					return nRoute;
				}
			}
		}
		
		return new LinkedList<Node>();
	}
}
